version: '3'
services:

  postgres:
    image: postgres
    ports:
      - 5433:5432
    environment:
      - POSTGRES_DB=consumo_gasolina
      - POSTGRES_PASSWORD=123456
    volumes:
      - db-data:/var/lib/postgresql/data
    networks:
      - backend

  core:
    image: registry.gitlab.com/jotha.pessoa/consumo-gasolina-recife
    depends_on:
      - postgres
    ports:
      - 8000:8000
    working_dir: /usr/src/app
    command: /bin/sh -c "./wait.py postgres 5432 180 && python -u manage.py migrate && python -u production-server.py"
    networks:
      - backend
    deploy:
      mode: replicated
      replicas: 1
      labels: [APP=API]
      restart_policy:
        condition: on-failure
        delay: 10s
        max_attempts: 3
        window: 120s

  jmeter:
    image: justb4/jmeter
    depends_on:
      - core
    working_dir: /tmp
    volumes:
        - .:/tmp
    entrypoint: >-
                /bin/sh -c "./wait-for-it.sh -t 180 core:8000 -- echo 'core is up'
                && jmeter -Jhostname=core -Jport=8000 -Jvirtual_user=5 -Jstart_time=10 -Jduration=120 -n -t supply.jmx
                && jmeter -g supply.csv -o html_report"
    networks:
      - backend

networks:
  backend:

volumes:
  db-data:
